Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_writefile.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_writefile.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_writefile.php	(revision )
@@ -0,0 +1,90 @@
+<?php
+/**
+ * Smarty write file plugin
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Monte Ohrt
+ */
+
+/**
+ * Smarty Internal Write File Class
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ */
+class Smarty_Internal_Runtime_WriteFile
+{
+    /**
+     * Writes file in a safe way to disk
+     *
+     * @param  string $_filepath complete filepath
+     * @param  string $_contents file content
+     * @param  Smarty $smarty    smarty instance
+     *
+     * @throws SmartyException
+     * @return boolean true
+     */
+    public function writeFile($_filepath, $_contents, Smarty $smarty)
+    {
+        $_error_reporting = error_reporting();
+        error_reporting($_error_reporting & ~E_NOTICE & ~E_WARNING);
+        $_file_perms = property_exists($smarty, '_file_perms') ? $smarty->_file_perms : 0644;
+        $_dir_perms = property_exists($smarty, '_dir_perms') ? (isset($smarty->_dir_perms) ? $smarty->_dir_perms : 0777)  : 0771;
+        if ($_file_perms !== null) {
+            $old_umask = umask(0);
+        }
+
+        $_dirpath = dirname($_filepath);
+        // if subdirs, create dir structure
+        if ($_dirpath !== '.' && !file_exists($_dirpath)) {
+            mkdir($_dirpath, $_dir_perms, true);
+        }
+
+        // write to tmp file, then move to overt file lock race condition
+        $_tmp_file = $_dirpath . DS . str_replace(array('.', ','), '_', uniqid('wrt', true));
+        if (!file_put_contents($_tmp_file, $_contents)) {
+            error_reporting($_error_reporting);
+            throw new SmartyException("unable to write file {$_tmp_file}");
+       }
+
+        /*
+         * Windows' rename() fails if the destination exists,
+         * Linux' rename() properly handles the overwrite.
+         * Simply unlink()ing a file might cause other processes
+         * currently reading that file to fail, but linux' rename()
+         * seems to be smart enough to handle that for us.
+         */
+        if (Smarty::$_IS_WINDOWS) {
+            // remove original file
+            if (is_file($_filepath)) {
+                @unlink($_filepath);
+            }
+            // rename tmp file
+            $success = @rename($_tmp_file, $_filepath);
+        } else {
+            // rename tmp file
+            $success = @rename($_tmp_file, $_filepath);
+            if (!$success) {
+                // remove original file
+                if (is_file($_filepath)) {
+                    @unlink($_filepath);
+                }
+                // rename tmp file
+                $success = @rename($_tmp_file, $_filepath);
+            }
+        }
+        if (!$success) {
+            error_reporting($_error_reporting);
+            throw new SmartyException("unable to write file {$_filepath}");
+        }
+        if ($_file_perms !== null) {
+            // set file permissions
+            chmod($_filepath, $_file_perms);
+            umask($old_umask);
+        }
+        error_reporting($_error_reporting);
+
+        return true;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smartycompilerexception.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smartycompilerexception.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smartycompilerexception.php	(revision )
@@ -0,0 +1,39 @@
+<?php
+
+/**
+ * Smarty compiler exception class
+ *
+ * @package Smarty
+ */
+class SmartyCompilerException extends SmartyException
+{
+    public function __toString()
+    {
+        return ' --> Smarty Compiler: ' . $this->message . ' <-- ';
+    }
+
+    /**
+     * The line number of the template error
+     *
+     * @type int|null
+     */
+    public $line = null;
+    /**
+     * The template source snippet relating to the error
+     *
+     * @type string|null
+     */
+    public $source = null;
+    /**
+     * The raw text of the error message
+     *
+     * @type string|null
+     */
+    public $desc = null;
+    /**
+     * The resource identifier or template name
+     *
+     * @type string|null
+     */
+    public $template = null;
+}
Index: src/includes/classes/Smarty/plugins/outputfilter.trimwhitespace.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/outputfilter.trimwhitespace.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/outputfilter.trimwhitespace.php	(revision )
@@ -45,7 +45,7 @@
 
     // capture html elements not to be messed with
     $_offset = 0;
-    if (preg_match_all('#<(script|pre|textarea)[^>]*>.*?</\\1>#is', $source, $matches, PREG_OFFSET_CAPTURE | PREG_SET_ORDER)) {
+    if (preg_match_all('#(<script[^>]*>.*?</script[^>]*>)|(<textarea[^>]*>.*?</textarea[^>]*>)|(<pre[^>]*>.*?</pre[^>]*>)#is', $source, $matches, PREG_OFFSET_CAPTURE | PREG_SET_ORDER)) {
         foreach ($matches as $match) {
             $store[] = $match[0][0];
             $_length = strlen($match[0][0]);
@@ -62,7 +62,7 @@
         // can't remove them entirely, becaue that might break poorly implemented CSS display:inline-block elements
         '#(:SMARTY@!@|>)\s+(?=@!@SMARTY:|<)#s'                            => '\1 \2',
         // remove spaces between attributes (but not in attribute values!)
-        '#(([a-z0-9]\s*=\s*(["\'])[^\3]*?\3)|<[a-z0-9_]+)\s+([a-z/>])#is' => '\1 \4',
+        '#(([a-z0-9]\s*=\s*("[^"]*?")|(\'[^\']*?\'))|<[a-z0-9_]+)\s+([a-z/>])#is' => '\1 \5',
         // note: for some very weird reason trim() seems to remove spaces inside attributes.
         // maybe a \0 byte or something is interfering?
         '#^\s+<#Ss'                                                       => '<',
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_configload.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_configload.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_configload.php	(revision )
@@ -0,0 +1,182 @@
+<?php
+
+/**
+ * Smarty Method ConfigLoad
+ *
+ * Smarty::configLoad() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ConfigLoad
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * load a config file, optionally load just selected sections
+     *
+     * @api  Smarty::configLoad()
+     * @link http://www.smarty.net/docs/en/api.config.load.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string                                                 $config_file filename
+     * @param  mixed                                                  $sections    array of section names, single
+     *                                                                             section or null
+     *
+     * @return \Smarty|\Smarty_Internal_Data|\Smarty_Internal_Template
+     * @throws \SmartyException
+     */
+    public function configLoad(Smarty_Internal_Data $data, $config_file, $sections = null)
+    {
+        $this->_loadConfigFile($data, $config_file, $sections, 0);
+        return $data;
+    }
+
+    /**
+     * load a config file, optionally load just selected sections
+     *
+     * @api  Smarty::configLoad()
+     * @link http://www.smarty.net/docs/en/api.config.load.tpl
+     *
+     * @param \Smarty|\Smarty_Internal_Data|\Smarty_Internal_Template $data
+     * @param  string                                                 $config_file filename
+     * @param  mixed                                                  $sections    array of section names, single
+     *                                                                             section or null
+     * @param int                                                     $scope       scope into which config variables
+     *                                                                             shall be loaded
+     *
+     * @return \Smarty|\Smarty_Internal_Data|\Smarty_Internal_Template
+     * @throws \SmartyException
+     */
+    public function _loadConfigFile(Smarty_Internal_Data $data, $config_file, $sections = null, $scope = 0)
+    {
+        /* @var \Smarty $smarty */
+        $smarty = isset($data->smarty) ? $data->smarty : $data;
+        /* @var \Smarty_Internal_Template $confObj */
+        $confObj = new Smarty_Internal_Template($config_file, $smarty, $data);
+        $confObj->caching = Smarty::CACHING_OFF;
+        $confObj->source = Smarty_Template_Config::load($confObj);
+        $confObj->source->config_sections = $sections;
+        $confObj->source->scope = $scope;
+        $confObj->compiled = Smarty_Template_Compiled::load($confObj);
+        $confObj->compiled->render($confObj);
+        if ($data->_objType == 2) {
+            $data->compiled->file_dependency[$confObj->source->uid] =
+                array($confObj->source->filepath, $confObj->source->getTimeStamp(), $confObj->source->type);
+        }
+    }
+
+    /**
+     * load config variables into template object
+     *
+     * @param \Smarty_Internal_Template $tpl
+     * @param  array                    $_config_vars
+     *
+     */
+    public function _loadConfigVars(Smarty_Internal_Template $tpl, $_config_vars)
+    {
+        $this->_assignConfigVars($tpl->parent, $tpl, $_config_vars);
+        $scope = $tpl->source->scope;
+        if (!$scope && !$tpl->scope) {
+            return;
+        }
+        foreach (array($scope, $tpl->scope) as $s) {
+            $s = ($bubble_up = $s >= Smarty::SCOPE_BUBBLE_UP) ? $s - Smarty::SCOPE_BUBBLE_UP : $s;
+            if ($bubble_up && $s) {
+                $ptr = $tpl->parent->parent;
+                if (isset($ptr)) {
+                    $this->_assignConfigVars($ptr, $tpl, $_config_vars);
+                    $ptr = $ptr->parent;
+                }
+                if ($s == Smarty::SCOPE_PARENT) {
+                    continue;
+                }
+                while (isset($ptr) && $ptr->_objType == 2) {
+                    $this->_assignConfigVars($ptr, $tpl, $_config_vars);
+                    $ptr = $ptr->parent;
+                }
+                if ($s == Smarty::SCOPE_TPL_ROOT) {
+                    continue;
+                } elseif ($s == Smarty::SCOPE_SMARTY) {
+                    $this->_assignConfigVars($tpl->smarty, $tpl, $_config_vars);
+                } elseif ($s == Smarty::SCOPE_GLOBAL) {
+                    $this->_assignConfigVars($tpl->smarty, $tpl, $_config_vars);
+                } elseif ($s == Smarty::SCOPE_ROOT) {
+                    while (isset($ptr->parent)) {
+                        $ptr = $ptr->parent;
+                    }
+                    $this->_assignConfigVars($ptr, $tpl, $_config_vars);
+                }
+            }
+        }
+    }
+
+    /**
+     * Assign all config variables in given scope
+     *
+     * @param \Smarty_Internal_Data     $scope_ptr
+     * @param \Smarty_Internal_Template $tpl
+     * @param  array                    $_config_vars
+     */
+    public function _assignConfigVars(Smarty_Internal_Data $scope_ptr, Smarty_Internal_Template $tpl, $_config_vars)
+    {
+        // copy global config vars
+        foreach ($_config_vars['vars'] as $variable => $value) {
+            if ($tpl->smarty->config_overwrite || !isset($scope_ptr->config_vars[$variable])) {
+                $scope_ptr->config_vars[$variable] = $value;
+            } else {
+                $scope_ptr->config_vars[$variable] =
+                    array_merge((array) $scope_ptr->config_vars[$variable], (array) $value);
+            }
+        }
+        // scan sections
+        $sections = $tpl->source->config_sections;
+        if (!empty($sections)) {
+            foreach ((array) $sections as $tpl_section) {
+                if (isset($_config_vars['sections'][$tpl_section])) {
+                    foreach ($_config_vars['sections'][$tpl_section]['vars'] as $variable => $value) {
+                        if ($tpl->smarty->config_overwrite || !isset($scope_ptr->config_vars[$variable])) {
+                            $scope_ptr->config_vars[$variable] = $value;
+                        } else {
+                            $scope_ptr->config_vars[$variable] =
+                                array_merge((array) $scope_ptr->config_vars[$variable], (array) $value);
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    /**
+     * gets  a config variable value
+     *
+     * @param \Smarty_Internal_Template $tpl     template object
+     * @param string                    $varName the name of the config variable
+     * @param bool                      $errorEnable
+     *
+     * @return mixed  the value of the config variable
+     */
+    public function _getConfigVariable(Smarty_Internal_Template $tpl, $varName, $errorEnable = true)
+    {
+        $_ptr = $tpl;
+        while ($_ptr !== null) {
+            if (isset($_ptr->config_vars[$varName])) {
+                // found it, return it
+                return $_ptr->config_vars[$varName];
+            }
+            // not found, try at parent
+            $_ptr = $_ptr->parent;
+        }
+        if ($tpl->smarty->error_unassigned && $errorEnable) {
+            // force a notice
+            $x = $$varName;
+        }
+        return null;
+    }
+}
Index: src/includes/classes/Smarty/plugins/function.fetch.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/function.fetch.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/function.fetch.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_unloadfilter.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_unloadfilter.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_unloadfilter.php	(revision )
@@ -0,0 +1,42 @@
+<?php
+
+/**
+ * Smarty Method UnloadFilter
+ *
+ * Smarty::unloadFilter() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_UnloadFilter extends Smarty_Internal_Method_LoadFilter
+{
+    /**
+     * load a filter of specified type and name
+     *
+     * @api  Smarty::unloadFilter()
+     *
+     * @link http://www.smarty.net/docs/en/api.unload.filter.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type filter type
+     * @param  string                                                         $name filter name
+     *
+     * @return bool
+     */
+    public function unloadFilter(Smarty_Internal_TemplateBase $obj, $type, $name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        $this->_checkFilterType($type);
+        if (isset($smarty->registered_filters[$type])) {
+            $_filter_name = "smarty_{$type}filter_{$name}";
+            if (isset($smarty->registered_filters[$type][$_filter_name])) {
+                unset ($smarty->registered_filters[$type][$_filter_name]);
+                if (empty($smarty->registered_filters[$type])) {
+                    unset($smarty->registered_filters[$type]);
+                }
+            }
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/shared.escape_special_chars.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/shared.escape_special_chars.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/shared.escape_special_chars.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_function.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_function.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_registered_function.php	(revision )
@@ -27,14 +27,14 @@
     /**
      * Compiles code for the execution of a registered function
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
-     * @param  string $tag       name of function
+     * @param  string                                      $tag       name of function
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter, $tag)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter, $tag)
     {
         // This tag does create output
         $compiler->has_output = true;
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_getconfigvars.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_getconfigvars.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_getconfigvars.php	(revision )
@@ -0,0 +1,58 @@
+<?php
+
+/**
+ * Smarty Method GetConfigVars
+ *
+ * Smarty::getConfigVars() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetConfigVars
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * Returns a single or all config variables
+     *
+     * @api  Smarty::getConfigVars()
+     * @link http://www.smarty.net/docs/en/api.get.config.vars.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string                                                 $varname        variable name or null
+     * @param  bool                                                   $search_parents include parent templates?
+     *
+     * @return mixed variable value or or array of variables
+     */
+    public function getConfigVars(Smarty_Internal_Data $data, $varname = null, $search_parents = true)
+    {
+        $_ptr = $data;
+        $var_array = array();
+        while ($_ptr !== null) {
+            if (isset($varname)) {
+                if (isset($_ptr->config_vars[$varname])) {
+                    return $_ptr->config_vars[$varname];
+                }
+            } else {
+                $var_array = array_merge($_ptr->config_vars, $var_array);
+            }
+            // not found, try at parent
+            if ($search_parents) {
+                $_ptr = $_ptr->parent;
+            } else {
+                $_ptr = null;
+            }
+        }
+        if (isset($varname)) {
+            return '';
+        } else {
+            return $var_array;
+        }
+    }
+}
\ No newline at end of file
